package cn.com.qmth.examcloud.core.reports.api.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.core.reports.api.ExamStudentCountCloudService;
import cn.com.qmth.examcloud.core.reports.api.request.AddOrUpdateExamStudentCountReq;
import cn.com.qmth.examcloud.core.reports.api.response.AddOrUpdateExamStudentCountResp;
import cn.com.qmth.examcloud.core.reports.service.ExamStudentCountService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "考生在线人数接口")
@RequestMapping("${$rmp.cloud.reports}" + "examStudentCount")
public class ExamStudentCountCloudServiceProvider extends ControllerSupport implements ExamStudentCountCloudService {
	/**
	 * 
	 */
	private static final long serialVersionUID = 3223439983825840881L;
	@Autowired
	private ExamStudentCountService examStudentCountService;

	@ApiOperation(value = "新增或更新在线人数")
	@PostMapping("/addOrUpdateCount")
	@Override
	public AddOrUpdateExamStudentCountResp addOrUpdateCount(@RequestBody AddOrUpdateExamStudentCountReq req) {
		if (req.getRootOrgId() == null) {
			throw new StatusException("1000001", "rootOrgId不能为空");
		}
		if (req.getOrgId() == null) {
			throw new StatusException("1000002", "orgId不能为空");
		}
		if (req.getExamId() == null) {
			throw new StatusException("1000003", "examId不能为空");
		}
		if(req.getBatchTime()==null) {
			throw new StatusException("1000004", "batchTime不能为空");
		}
		examStudentCountService.addOrUpdateCount(req);
		return new AddOrUpdateExamStudentCountResp();
	}
}
