package cn.com.qmth.examcloud.core.reports.api.provider;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import cn.com.qmth.examcloud.commons.exception.StatusException;
import cn.com.qmth.examcloud.core.reports.api.UserCountCloudService;
import cn.com.qmth.examcloud.core.reports.api.request.AddOrUpdateUserCountReq;
import cn.com.qmth.examcloud.core.reports.api.response.AddOrUpdateUserCountResp;
import cn.com.qmth.examcloud.core.reports.service.UserCountService;
import cn.com.qmth.examcloud.web.support.ControllerSupport;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@RestController
@Api(tags = "后台用户在线人数接口")
@RequestMapping("${$rmp.cloud.reports}"+"userCount")
public class UserCountCloudServiceProvider extends ControllerSupport implements UserCountCloudService {

	/**
	 * 
	 */
	private static final long serialVersionUID = -3472625622982671318L;
	@Autowired
	private UserCountService userCountService;
	
	@ApiOperation(value = "新增或更新在线人数")
    @PostMapping("/addOrUpdateCount")
	@Override
	public AddOrUpdateUserCountResp addOrUpdateCount(@RequestBody AddOrUpdateUserCountReq req) {
		if(req.getRootOrgId()==null) {
			throw new StatusException("1000001", "rootOrgId不能为空");
		}
		if(req.getOrgId()==null) {
			throw new StatusException("1000002", "orgId不能为空");
		}
		if(req.getBatchTime()==null) {
			throw new StatusException("1000003", "batchTime不能为空");
		}
		userCountService.addOrUpdateCount(req);
		return new AddOrUpdateUserCountResp();
	}


}
