package cn.com.qmth.examcloud.core.reports.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import cn.com.qmth.examcloud.core.reports.api.request.AddOrUpdateStudentCountReq;
import cn.com.qmth.examcloud.core.reports.dao.StudentCountRepo;
import cn.com.qmth.examcloud.core.reports.dao.entity.StudentCountEntity;
import cn.com.qmth.examcloud.core.reports.service.StudentCountService;

@Service
public class StudentCountServiceImpl implements StudentCountService {
	@Autowired
	private StudentCountRepo studentCountRepo;
	@Autowired
	private JdbcTemplate jdbcTemplate;

	@Override
	public void addOrUpdateCount(AddOrUpdateStudentCountReq req) {
		StudentCountEntity e = studentCountRepo.findByRootOrgIdAndOrgId(req.getRootOrgId(), req.getOrgId());
		if (e == null) {
			e = new StudentCountEntity();
			e.setRootOrgId(req.getRootOrgId());
			e.setOrgId(req.getOrgId());
		}
		e.setBatchTime(req.getBatchTime());
		e.setOnlineCount(req.getOnlineCount());
		studentCountRepo.save(e);
	}

	@Override
	public Long getOnlineCount(Long rootOrgId, Long orgId) {
		StringBuffer sb = new StringBuffer();
		sb.append(" select sum(t.online_count) from ec_r_student_count t where t.root_org_id=").append(rootOrgId);
		sb.append(" and t.batch_time=(select f.batch_time from ec_r_student_count f order by f.batch_time desc limit 1) ");
		if (orgId != null) {
			sb.append(" and t.org_id=").append(orgId);
		}
		Long count = jdbcTemplate.queryForObject(sb.toString(), Long.class);
		if (count == null) {
			count = 0l;
		}
		return count;
	}
}
